﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace Test_RichSee
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Guid _instanceGUID;
        //private SingleModelPlayer _ModelPlayer;
        private CreationFilter _CreationFilter;
        //private SIMLibraryBC _SimLibraryBC;
        private bool _IsDragInternal = false;
        /*

        #region IPaletteModule

        public bool Enabled1
        {
            // Implement any logic for checking the conditions for using this palette here
            // e.g. if component used by this palette is present
            // If this method return false, the palette will not be shown to the user
            get { return true; }
        }

        public Guid InstanceGuid
        {
            get
            {
                // Lazy initialization, create when first used
                if (_instanceGUID == Guid.Empty)
                {
                    _instanceGUID = Guid.NewGuid();
                }

                // Return the GUID identifying an instance of the palette

                return _instanceGUID;
            }
        }

        bool IModule.Enabled
        {
            get { return Enabled1; }
        }

        void IPaletteModule.Load()
        {
            Load1();
        }

        public void SetPlayer(SingleModelPlayer player)
        {
            _ModelPlayer = player;
        }

        public void Unload()
        {
            // This method is called when the palette is closed and is no longer accessible to the user
            // The cleanup code should
            // - release all references to objects in the model view
            // - set the model player to nothing (automatically removes handlers)            
            _ModelPlayer = null;

        }

        public UserControl UserControl
        {
            get { return this; }
        }

        public void Load1()
        {

        }

        #endregion

        */

        /*
        #region IModule

        public string Name1
        {
            // This name is shown to the user as the name of the palette
            // Localization can be done here if needed
            get { return "Zone Grouping"; }
        }

        string IModule.Name
        {
            get { return Name1; }
        }

        public string Description
        {
            // This description is shown to the user e.g. in tooltips
            // Localization can be done here if needed
            get { return "Zone Grouping Palette"; }
        }

        public Guid Guid
        {
            get { return new Guid("62FFF98D-028E-4142-9B9D-CAFDB7DC12E8"); }
        }

        public Bitmap Image
        {
            get { return null; }
        }

        #endregion

        */
        #region Events

        void ZoneGroupingTemplate_Load(object sender, System.EventArgs e)
        {

            //_SimLibraryBC = new SIMLibraryBC();

            _CreationFilter = new CreationFilter();
            this.ultraGrid1.CreationFilter = _CreationFilter;


            ultraGrid1.DataSource = ultraDataSource1;

            this.ultraGrid1.DisplayLayout.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.True;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.True;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns[0].CellActivation = Infragistics.Win.UltraWinGrid.Activation.AllowEdit;


            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONEGROUPLIST].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedText;

            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_OCCUPANCYANDCOMFORT].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_OCCUPANCYANDCOMFORT].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_LIGHTSANDDAYLIGHTING].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_LIGHTSANDDAYLIGHTING].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONDITIONS].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONDITIONS].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONSTRUCTION].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONSTRUCTION].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONENONHVACEQUIPMENT].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONENONHVACEQUIPMENT].ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;



            //this.ultraComboEditor1.DisplayMember = "MemberTemplateName";
            //this.ultraComboEditor2.DisplayMember = "MemberTemplateName";
            //this.ultraComboEditor3.DisplayMember = "MemberTemplateName";
            //this.ultraComboEditor4.DisplayMember = Constants.MemberTemplateName;
            //this.ultraComboEditor5.DisplayMember = Constants.MemberTemplateName;
            //this.ultraComboEditor1.ValueMember = Constants.MemberUniqueId;
            //this.ultraComboEditor2.ValueMember = Constants.MemberUniqueId;
            //this.ultraComboEditor3.ValueMember = Constants.MemberUniqueId;
            //this.ultraComboEditor4.ValueMember = Constants.MemberUniqueId;
            //this.ultraComboEditor5.ValueMember = Constants.MemberUniqueId;



            //this.ultraComboEditor1.DataSource = PopulateTemplateList(Identities.ENT_SimTemplateOccupancyAndComfort);
            //this.ultraComboEditor2.DataSource = PopulateTemplateList(Identities.ENT_SimTemplateLightsAndDaylighting);
            //this.ultraComboEditor3.DataSource = PopulateTemplateList(Identities.ENT_SimTemplateZoneConditions);
            //this.ultraComboEditor4.DataSource = PopulateTemplateList(Identities.ENT_SimTemplateZoneConstructions);
            //this.ultraComboEditor5.DataSource = PopulateTemplateList(Identities.ENT_SimTemplateNonHvacZoneEquipment);


            //this.ultraComboEditor1.Tag = Identities.ENT_SimTemplateOccupancyAndComfort;
            //this.ultraComboEditor2.Tag = Identities.ENT_SimTemplateLightsAndDaylighting;
            //this.ultraComboEditor3.Tag = Identities.ENT_SimTemplateZoneConditions;
            //this.ultraComboEditor4.Tag = Identities.ENT_SimTemplateZoneConstructions;
            //this.ultraComboEditor5.Tag = Identities.ENT_SimTemplateNonHvacZoneEquipment;


            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_OCCUPANCYANDCOMFORT].EditorComponent = this.ultraComboEditor1;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_LIGHTSANDDAYLIGHTING].EditorComponent = this.ultraComboEditor2;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONDITIONS].EditorComponent = this.ultraComboEditor3;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONECONSTRUCTION].EditorComponent = this.ultraComboEditor4;
            ultraGrid1.DisplayLayout.Bands[0].Columns[PaletteZoneTemplateConstants.COLUMN_ZONENONHVACEQUIPMENT].EditorComponent = this.ultraComboEditor5;


            //Load existing zone groups
            //LoadExistingZoneGroups();
        }

        #region  These is not connected with the Issue
        /*
        
        void ultraGrid1_CellListSelect(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            if (e.Cell.Text != string.Empty && e.Cell.Text != Constants.DefaultTemplates && e.Cell.Text != Constants.ProjTemplates)
            {
                //SimGroup currentGroup = new SimGroup((Row)((Infragistics.Win.UltraWinDataSource.UltraDataRow)e.Cell.Row.ListObject).Tag);

                //UltraComboEditor ultraComboEditor = (UltraComboEditor)e.Cell.Column.EditorComponent;
                //ReferenceValue referenceToBeRemoved = null;
                //string simTemplateClassName = (string)ultraComboEditor.Tag;
                //string templateType = GetTemplateType(simTemplateClassName);
                //string cellText = e.Cell.Text;
                //string cellKey = e.Cell.Column.Key;

                ////Check if selected Template is already Copied in the current Model
                ////The below method returns the Template Object of Particular Class if it exists in current Model
                //SimBase templateobj = _SimLibraryBC.CheckIfTemplateExists(e.Cell.Text, simTemplateClassName, _ModelPlayer.ActiveModel);

                ////If Template doestnot exists, Copy it to the local Model
                //if (templateobj == null)
                //    templateobj = _SimLibraryBC.CopyTemplate(_ModelPlayer.ActiveModel, templateType, simTemplateClassName, e.Cell.Text, currentGroup);



                ////Check to see if the reference value already exist. If it does do not add it again.
                //if (!currentGroup.TemplatesForMembers.get_Contains(templateobj.get_Row(_ModelPlayer.ActiveModel).Reference))
                //{
                //    //check if there is an existing reference value already in that column. If yes then replace with the newly selected row.
                //    if (e.Cell.Text != string.Empty)
                //    {
                //        foreach (ReferenceValue referenceValue in currentGroup.TemplatesForMembers)
                //        {
                //            SimBase simBase = SimWrapperFromRowFactory.GetWrapper(_ModelPlayer.ActiveModel.Helper.GetTableRow(referenceValue));

                //            object simModelType = new object();
                //            if (simBase.TryGetPropertyValue(Identities.PROP_SimModelType, ref simModelType))
                //            {
                //                string columnName = GetCorrelatingColumnName((string)simModelType);
                //                if (columnName.ToLower() == e.Cell.Column.ToString().ToLower())
                //                {
                //                    referenceToBeRemoved = referenceValue;
                //                }
                //            }
                //        }
                //    }

                //    if (referenceToBeRemoved != null)
                //    {
                //        currentGroup.TemplatesForMembers.Remove(referenceToBeRemoved);
                //    }

                //    currentGroup.TemplatesForMembers.Add(templateobj.get_Row(_ModelPlayer.ActiveModel).Reference);
                //    currentGroup.Commit(_ModelPlayer.ActiveModel);
                //}



                //ultraComboEditor.DataSource = PopulateTemplateList(simTemplateClassName);


                //this.ultraGrid1.DisplayLayout.Rows[e.Cell.Row.Index].Cells[cellKey].Value = cellText;

                //return;
            }

            e.Cell.CancelUpdate();
        }

        void ultraGrid1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            //UltraDataRow newDataRow;
            //StringValue zoneGroupName;

            //if (e.Data != null)
            //{
            //    if (_IsDragInternal)
            //    {
            //        SelectedRowsCollection collection = (SelectedRowsCollection)e.Data.GetData(typeof(SelectedRowsCollection));

            //        foreach (UltraGridRow draggedUltraDataRow1 in collection)
            //        {
            //            UltraDataRow draggedUltraDataRow = (UltraDataRow)draggedUltraDataRow1.ListObject;

            //            Row draggedRow = (Row)draggedUltraDataRow.Tag;

            //            if (draggedRow.Table.Identities.get_Contains(Identities.ENT_SimSpatialZone))
            //            {
            //                // Try to get the grid row 
            //                UltraGridRow newParentRow = GetGridRowFromCoordinates(ultraGrid1.PointToClient(new Point(e.X, e.Y)));

            //                // If a row was found display the band and row index
            //                if ((newParentRow != null))
            //                {
            //                    if (newParentRow.Band.Index == 0)
            //                    {
            //                        //Add the new UltraDataRow to the new Band
            //                        zoneGroupName = null;
            //                        if (draggedRow.Helper.TryGetStringValue(Identities.PROP_SimModelName, ref zoneGroupName))
            //                            newDataRow = AddZoneRow(newParentRow, zoneGroupName.Value, draggedRow);
            //                        else
            //                            newDataRow = AddZoneRow(newParentRow, "Default Zone Name", draggedRow);

            //                        newDataRow.Tag = draggedRow;


            //                        UltraGridRow oldParentRow = ultraGrid1.Rows[draggedUltraDataRow.ParentRow.Index];
            //                        DeleteZoneRow(oldParentRow, draggedRow);
            //                    }
            //                    else
            //                    {
            //                        MessageBox.Show("Please drop on a zone group");
            //                    }
            //                }
            //            }
            //        }

            //        LoadExistingZoneGroups();
            //    }
            //    else
            //    {
            //        var rowColl = (RowCollection)e.Data.GetData(typeof(RowCollection));

            //        if (rowColl.Count > 0)
            //        {
            //            foreach (Row row in rowColl)
            //            {
            //                if (row.Table.Identities.get_Contains(Identities.ENT_SimSpatialZone))
            //                {
            //                    // Try to get the grid row 
            //                    UltraGridRow aRow =
            //                        GetGridRowFromCoordinates(ultraGrid1.PointToClient(new Point(e.X, e.Y)));

            //                    // If a row was found display the band and row index

            //                    if ((aRow != null))
            //                    {
            //                        if (aRow.Band.Index == 0)
            //                        {
            //                            // Get the zone name identity <-- TEMP: change this to be a name from simZone...
            //                            // Get the zone name cell
            //                            zoneGroupName = null;
            //                            if (row.Helper.TryGetStringValue(Identities.PROP_SimModelName, ref zoneGroupName))
            //                            {
            //                                newDataRow = AddZoneRow(aRow, zoneGroupName.Value, row);
            //                            }
            //                            else
            //                            {
            //                                newDataRow = AddZoneRow(aRow, "Default Zone Name", row);
            //                            }

            //                            // Add the original row view as the tag of the data row
            //                            newDataRow.Tag = row;
            //                        }
            //                        else
            //                        {
            //                            MessageBox.Show("Please drop on a zone group");
            //                        }
            //                    }
            //                }
            //            }
            //        }
            //    }
            //}
        }

        void ultraGrid1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            //if (!_IsDragInternal)
            //{
            //    if (e.Data == null)
            //    {
            //        e.Effect = System.Windows.Forms.DragDropEffects.None;
            //    }
            //    else
            //    {
            //        RowCollection rowColl = (RowCollection)e.Data.GetData(typeof(RowCollection));

            //        if (rowColl.Count > 0)
            //        {
            //            foreach (Datacubist.simplebim.Core.DataCube.DataModel.Row row in rowColl)
            //            {
            //                SimBase simWrapper = SimWrapperFromRowFactory.GetWrapper(row);
            //                object type = null;
            //                object subType = null;

            //                simWrapper.TryGetPropertyValue(Identities.PROP_SimModelType, ref type);
            //                simWrapper.TryGetPropertyValue(Identities.PROP_SimModelSubtype, ref subType);
            //                if (type != null && subType != null)
            //                {
            //                    if ((string)type == TypeSubtypeClassification.TYPE_THERMALZONE && (string)subType == TypeSubtypeClassification.SUBTYPE_DEFAULT)
            //                        e.Effect = DragDropEffects.Link;
            //                    else
            //                        e.Effect = System.Windows.Forms.DragDropEffects.None;
            //                }
            //                else
            //                {
            //                    e.Effect = System.Windows.Forms.DragDropEffects.None;
            //                }
            //            }
            //        }
            //        else
            //        {
            //            e.Effect = System.Windows.Forms.DragDropEffects.None;
            //        }

            //    }
            //}
            //else
            //{
            //    e.Effect = DragDropEffects.Move;
            //}

        }

        void ultraGrid1_SelectionDrag(object sender, System.ComponentModel.CancelEventArgs e)
        {

            //_IsDragInternal = true;
            //if (ultraGrid1.ActiveRow.ListObject.GetType() != typeof(UltraDataRow)) return;
            //ultraGrid1.DoDragDrop((UltraDataRow)ultraGrid1.ActiveRow.ListObject, DragDropEffects.Move);
            //_IsDragInternal = false;

            //_IsDragInternal = true;
            //if (ultraGrid1.ActiveRow.ListObject.GetType() != typeof(UltraDataRow)) return;
            //ultraGrid1.DoDragDrop(ultraGrid1.Selected.Rows, DragDropEffects.Move);
            //_IsDragInternal = false;
        }

        void ultraGrid1_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
        {
            //if (_IsDragInternal)
            //{
            //    e.Effect = DragDropEffects.Move;
            //    UltraGrid grid = sender as UltraGrid;
            //    Point pointInGridCoords = grid.PointToClient(new Point(e.X, e.Y));
            //    if (pointInGridCoords.Y < 20)
            //        // Scroll up.
            //        this.ultraGrid1.ActiveRowScrollRegion.Scroll(RowScrollAction.LineUp);
            //    else if (pointInGridCoords.Y > grid.Height - 20)
            //        // Scroll down.
            //        this.ultraGrid1.ActiveRowScrollRegion.Scroll(RowScrollAction.LineDown);
            //}
        }

        void ultraGrid1_ClickCell(object sender, Infragistics.Win.UltraWinGrid.ClickCellEventArgs e)
        {
            if (e.Cell.Column.Index == 0)
            {
                //e.Cell.CanEnterEditMode //<--- this is the offender
            }

        }
        
        */
        #endregion


        #endregion

        #region Methods - CHECK AGAIN

        /*
        public void CreateNewZoneGroup()
        {
            UltraDataRow dataRow = ultraDataSource1.Rows.Add();
            PaletteIdmTreeView paletteIDMTreeview;

            SimGroup zoneGroup = new SimGroup();

            zoneGroup.SimUniqueID = Guid.NewGuid().ToString();
            zoneGroup.SimModelType = TypeSubtypeClassification.TYPE_SPATIALZONEGROUP;
            zoneGroup.SimModelSubtype = TypeSubtypeClassification.SUBTYPE_ZONEGROUP;
            //zoneGroup.SimModelName = "Zone Group" + ultraDataSource1.Rows.Count;
            zoneGroup.SimModelName = ApplicationSettingsUtils.SetName(_ModelPlayer.ActiveModel, "Zone Group");
            if (GlobalVariables.CurrentBuilding.ReferenceValue != null)
                zoneGroup.ContainingBuildings.Add(GlobalVariables.CurrentBuilding.ReferenceValue);
            zoneGroup.Commit(_ModelPlayer.ActiveModel);

            dataRow[PaletteZoneTemplateConstants.COLUMN_ZONEGROUPLIST] = zoneGroup.SimModelName;
            dataRow.Tag = zoneGroup.get_Row(_ModelPlayer.ActiveModel);

            paletteIDMTreeview = GetIDM_TreeviewPalette();

            if (paletteIDMTreeview != null)
                paletteIDMTreeview.RebuildTree();
        }

        public void DeleteZoneGroup()
        {

            foreach (UltraGridRow ultraGridRow in ultraGrid1.Selected.Rows)
            {

            }
        }

        public void LoadExistingZoneGroups()
        {
            UltraDataRow dataRow;
            Table simGroupTable;
            SimGroup zoneGroup;
            UltraDataRow childThermalZone;

            simGroupTable = _ModelPlayer.ActiveModel.Tables[Identities.ENT_SimGroup];

            ultraDataSource1.Rows.Clear();

            if ((simGroupTable != null))
            {
                foreach (Row row in simGroupTable.Rows)
                {
                    zoneGroup = new SimGroup(row);

                    if (zoneGroup.SimModelType == TypeSubtypeClassification.TYPE_SPATIALZONEGROUP && zoneGroup.SimModelSubtype == TypeSubtypeClassification.SUBTYPE_ZONEGROUP)
                    {
                        dataRow = ultraDataSource1.Rows.Add();
                        dataRow[PaletteZoneTemplateConstants.COLUMN_ZONEGROUPLIST] = zoneGroup.SimModelName;
                        dataRow.Tag = row;

                        ReferenceValueList templatesForMembers = zoneGroup.TemplatesForMembers;

                        //Load row columns/dropdowns with data in the row
                        foreach (ReferenceValue referenceValue in templatesForMembers)
                        {
                            SimBase simBase = SimWrapperFromRowFactory.GetWrapper(_ModelPlayer.ActiveModel.Helper.GetTableRow(referenceValue));
                            object simModelType = new object();
                            if (simBase.TryGetPropertyValue(Identities.PROP_SimModelType, ref simModelType))
                            {
                                object simModelName = new object();
                                if (simBase.TryGetPropertyValue(Identities.PROP_SimModelName, ref simModelName))
                                {
                                    //base on the Sim Model type is the column we want to set the sim model name to
                                    dataRow[GetCorrelatingColumnName((string)simModelType)] = simModelName;
                                }
                            }
                        }


                        //Load children rows for each zone group
                        foreach (ReferenceValue member in zoneGroup.ChildGroups)
                        {
                            childThermalZone = dataRow.GetChildRows(PaletteZoneTemplateConstants.BAND_THERMALZONES).Add();
                            //Get Member data
                            Row refRow = _ModelPlayer.ActiveModel.Tables[member.TableKey].Rows[member.RowKey];
                            SimSpatialZone simSpatialZone = new SimSpatialZone(refRow);

                            childThermalZone[PaletteZoneTemplateConstants.COLUMN_THERMALZONE_NAME] = simSpatialZone.SimModelName;
                            childThermalZone.Tag = refRow;
                        }
                    }
                }

                //Expand all rows
                ultraGrid1.Rows.ExpandAll(true);
            }
        }

        private string GetCorrelatingColumnName(string simModelType)
        {
            switch (simModelType)
            {
                case TypeSubtypeClassification.TYPE_OCCUPANCYANDCOMFORT:
                    return PaletteZoneTemplateConstants.COLUMN_OCCUPANCYANDCOMFORT;
                case TypeSubtypeClassification.TYPE_LIGHTSANDDAYLIGHTING:
                    return PaletteZoneTemplateConstants.COLUMN_LIGHTSANDDAYLIGHTING;
                case TypeSubtypeClassification.TYPE_ZONECONDITIONS:
                    return PaletteZoneTemplateConstants.COLUMN_ZONECONDITIONS;
                case TypeSubtypeClassification.TYPE_ZONECONSTRUCTIONS:
                    return PaletteZoneTemplateConstants.COLUMN_ZONECONSTRUCTION;
                case TypeSubtypeClassification.TYPE_NONHVACZONEEQUIPMENT:
                    return PaletteZoneTemplateConstants.COLUMN_ZONENONHVACEQUIPMENT;
                default:
                    return null;
            }
        }

        public void LoadEditingTemplatePalette(ButtonUIElement buttonUIElement)
        {

            if (this.ultraGrid1.ActiveRow == null)
                return;

            string templateguid;
            string templateName = this.ultraGrid1.DisplayLayout.Rows[this.ultraGrid1.ActiveRow.Index].Cells[(((Infragistics.Win.UltraWinGrid.HeaderUIElement)(buttonUIElement.Parent)).Header).Column.Key].Value.ToString();
            string templateClass = (string)((System.Windows.Forms.Control)((((Infragistics.Win.UltraWinGrid.HeaderUIElement)(((Infragistics.Win.UIElement)(buttonUIElement)).Parent)).Header).Column.EditorComponent)).Tag;

            SimBase tempobj = _SimLibraryBC.CheckIfTemplateExists(templateName, templateClass, _ModelPlayer.ActiveModel);

            if (tempobj != null)
            {
                object guid = new object();
                tempobj.TryGetPropertyValue(Identities.PROP_SimUniqueID, ref guid);
                templateguid = guid.ToString();
            }

            else templateguid = templateName;

            //These are the mandatory parameters that need to be set
            //One is TemplateGUID -- w.r.t Local Model
            //Other is The type of the template. That is the KEY. Use Constants.cs
            //All keys have been listed there, with prefix TemplateType_
            GlobalVariables.selectedTemplateGuid = templateguid;
            GlobalVariables.selectedTemplate = GetTemplateType(templateClass);

            //Calling the workspace which has the palette with grid for custom editing
            //The GUID of the palette is "55b20062-2520-4c16-8f7e-2aa0035d0000"
            if (GlobalVariables.selectedTemplate != string.Empty)
            {
                EnergyPlusGUI.Common.FrameBroker.Frame.ModelPlayer.OpenWorkspace(GetWorkspaceGUID(templateClass));
            }
        }

        private string GetTemplateType(string simTemplateClassName)
        {
            switch (simTemplateClassName)
            {
                case Identities.ENT_SimTemplateOccupancyAndComfort:
                    return Constants.TemplateType_OccAndComf;
                case Identities.ENT_SimTemplateLightsAndDaylighting:
                    return Constants.TemplateType_LightsDaylightg;
                case Identities.ENT_SimTemplateZoneConditions:
                    return Constants.TemplateType_ZoneCondtns;
                case Identities.ENT_SimTemplateZoneConstructions:
                    return Constants.TemplateType_ZoneConstrtn;
                case Identities.ENT_SimTemplateNonHvacZoneEquipment:
                    return Constants.TemplateType_NonHVAC_Eqmt;
                default:
                    return null;
            }
        }

        private UltraGridRow GetGridRowFromCoordinates(Point point)
        {
            // Declare and retrieve a reference to the UIElement
            UIElement aUIElement = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(point);

            // Declare and retrieve a reference to the Row
            var aRow = (UltraGridRow)aUIElement.GetContext(typeof(UltraGridRow));

            // Return the row - may be Nothing
            return aRow;
        }

        private UltraDataRow AddZoneRow(UltraGridRow parentRow, string name, Row draggedRow)
        {
            UltraDataRow dataSimSpatialZoneRow;
            UltraDataRow dataZoneGroupRow;

            SimSpatialZone simSpatialZone;
            SimGroup simgroup;
            Row simGroupRow;

            // Get the data row
            dataZoneGroupRow = (UltraDataRow)parentRow.ListObject;


            // Add a row for the Zone member
            dataSimSpatialZoneRow = dataZoneGroupRow.GetChildRows(PaletteZoneTemplateConstants.BAND_THERMALZONES).Add();
            dataSimSpatialZoneRow[PaletteZoneTemplateConstants.COLUMN_THERMALZONE_NAME] = name;
            dataSimSpatialZoneRow.Tag = draggedRow;

            // Update ThermalZone object to reference the SimGroup to which it was just added
            simgroup = (SimGroup)SimWrapperFromRowFactory.GetWrapper((Row)dataZoneGroupRow.Tag);
            simGroupRow = simgroup.get_Row(_ModelPlayer.ActiveModel);

            simSpatialZone = (SimSpatialZone)SimWrapperFromRowFactory.GetWrapper((Row)dataSimSpatialZoneRow.Tag);
            // The SimSpatialZone object
            simSpatialZone.ParentGroups.Add(simGroupRow.Reference);
            simSpatialZone.Commit(_ModelPlayer.ActiveModel);

            parentRow.ExpandAll();

            return dataSimSpatialZoneRow;
        }

        private void DeleteZoneRow(UltraGridRow oldParentRow, Row draggedRow)
        {
            //UltraDataRow dataSimSpatialZoneRow;
            UltraDataRow dataZoneGroupRow;

            SimSpatialZone simSpatialZone;
            SimGroup simgroup;
            Row simGroupRow;

            // Get the data row
            dataZoneGroupRow = (UltraDataRow)oldParentRow.ListObject;

            //// Remove Row
            dataZoneGroupRow.GetChildRows(PaletteZoneTemplateConstants.BAND_THERMALZONES).Remove(dataZoneGroupRow, true);

            // Update ThermalZone object to reference the SimGroup to which it was just added
            simgroup = (SimGroup)SimWrapperFromRowFactory.GetWrapper((Row)dataZoneGroupRow.Tag);
            simGroupRow = simgroup.get_Row(_ModelPlayer.ActiveModel);

            simSpatialZone = (SimSpatialZone)SimWrapperFromRowFactory.GetWrapper(draggedRow);
            // The SimSpatialZone object
            simSpatialZone.ParentGroups.Remove(simGroupRow.Reference);
            simSpatialZone.Commit(_ModelPlayer.ActiveModel);
        }

        private DataTable PopulateTemplateList(string simTemplateIdentity)
        {
            DataTable templatelist = new DataTable();

            templatelist = _SimLibraryBC.GetTemplateList(simTemplateIdentity, _ModelPlayer.ActiveModel, null);

            return templatelist;
        }

        private Palettes.PaletteIdmTreeView GetIDM_TreeviewPalette()
        {
            try
            {
                System.Collections.ObjectModel.ReadOnlyCollection<Datacubist.simplebim.Developer.UI.IPaletteModule>
                    paletteInstances = _ModelPlayer.GetPaletteInstances(new Guid("C5D4F68B-0133-4a6c-902E-434FF0FD08B7"));
                foreach (Datacubist.simplebim.Developer.UI.IPaletteModule palette in paletteInstances)
                {
                    return (Palettes.PaletteIdmTreeView)palette;
                }
            }
            catch (Exception ex)
            {
                EnergyPlusGUI.Common.Logging.LogManager.LogMessage(ex.Message);
            }
            return null;
        }

        private Guid GetWorkspaceGUID(string simTemplateClassName)
        {
            switch (simTemplateClassName)
            {
                case Identities.ENT_SimTemplateOccupancyAndComfort:
                    return new Guid("58449FBF-BCE3-4918-B778-A72DBD22A629");
                case Identities.ENT_SimTemplateLightsAndDaylighting:
                    return new Guid("3B5B3FD2-3284-4922-BE10-1EBD2F9A3149");
                case Identities.ENT_SimTemplateZoneConditions:
                    return new Guid("04EB8AA2-1262-4546-B9F0-13A354A99146");
                case Identities.ENT_SimTemplateZoneConstructions:
                    return new Guid("CBD9752C-F21E-4e0e-8014-966391F412CB");
                case Identities.ENT_SimTemplateNonHvacZoneEquipment:
                    return new Guid("CD011492-35A4-4880-8F64-B261D6A7EDBB");
                default:
                    return new Guid("");
            }
        }

        */
        #endregion

    }

    public class CreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(Infragistics.Win.UIElement parent)
        {
            if (!(parent is HeaderUIElement))
                return;
            // get the associated column
            UltraGridColumn column = parent.GetContext(typeof(UltraGridColumn)) as UltraGridColumn;
            //** Return if the column isn't the one we want to add the button to or you can remove this condition.It will show button on all the column*****************.
            if (column == null)
            {
                return;
            }
            else
            {

                if (column.Key == PaletteZoneTemplateConstants.COLUMN_ZONEGROUPLIST)
                {
                    // create a new button element
                    ButtonUIElement buttonNew = new ButtonUIElement(parent);
                    // hook into its click event
                    //buttonNew.ElementClick +=
                    //new UIElementEventHandler(this.OnCustomButtonClick);

                    Rectangle buttonRect = new Rectangle();
                    buttonRect.Width = 70;
                    buttonRect.Height = 26;
                    // set the button element's rect
                    buttonNew.Rect = buttonRect;
                    buttonNew.Text = PaletteZoneTemplateConstants.BUTTON_NEW_GROUP;
                    parent.ChildElements.Add(buttonNew);

                    int widthCenter = parent.RectInsideBorders.X + (parent.RectInsideBorders.Width / 2);
                    int heightCenter = (parent.RectInsideBorders.Y + ((int)((double)parent.RectInsideBorders.Height / 2)) - 10);

                    buttonNew.Rect = new Rectangle(widthCenter / 2 - ((widthCenter / 2) / 2), heightCenter - ((int)((double)(heightCenter / 2))), buttonRect.Width, buttonRect.Height);



                    // create a new button element
                    ButtonUIElement buttonDelete = new ButtonUIElement(parent);
                    // hook into its click event
                    //buttonDelete.ElementClick +=
                    //new UIElementEventHandler(this.OnCustomButtonClick);

                    buttonRect = new Rectangle();
                    buttonRect.Width = 70;
                    buttonRect.Height = 26;
                    // set the button element's rect
                    buttonDelete.Rect = buttonRect;
                    buttonDelete.Text = PaletteZoneTemplateConstants.BUTTON_DELETE_GROUP;
                    parent.ChildElements.Add(buttonDelete);

                    buttonDelete.Rect = new Rectangle(widthCenter + ((widthCenter / 2) / 2), heightCenter - ((int)((double)(heightCenter / 2))), buttonRect.Width, buttonRect.Height);

                }
                else
                {

                    // create a new button element
                    ButtonUIElement buttonAdd = new ButtonUIElement(parent);
                    // hook into its click event
                    //buttonAdd.ElementClick +=
                    //new UIElementEventHandler(this.OnCustomButtonClick);
                    // get the rect of the parent element inside its borders
                    Rectangle buttonRect = new Rectangle();
                    // *********set the width & height of the button's rect***********
                    buttonRect.Width = 130;
                    buttonRect.Height = 31;
                    // set the button element's rect
                    buttonAdd.Rect = buttonRect;
                    buttonAdd.Text = PaletteZoneTemplateConstants.BUTTON_EDIT_TEMPLATE_VALUES;
                    parent.ChildElements.Add(buttonAdd);

                    int widthCenter = parent.RectInsideBorders.X + (parent.RectInsideBorders.Width / 2);
                    int heightCenter = parent.RectInsideBorders.Y + (int)((double)parent.RectInsideBorders.Height / 2.5);

                    buttonAdd.Rect = new Rectangle(widthCenter - (buttonRect.Width / 2), heightCenter - (buttonRect.Height / 2), buttonRect.Width, buttonRect.Height);

                }

            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        /*
        private void OnCustomButtonClick(Object sender, Infragistics.Win.UIElementEventArgs e)
        {
            //Depending on button we do code

            ButtonUIElement buttonUIElement = (ButtonUIElement)e.Element;

            switch ((((Infragistics.Win.UltraWinGrid.HeaderUIElement)(buttonUIElement.Parent)).Header).Column.Key)
            {
                case PaletteZoneTemplateConstants.COLUMN_ZONEGROUPLIST:

                    switch (buttonUIElement.Text)
                    {
                        case PaletteZoneTemplateConstants.BUTTON_NEW_GROUP:
                            getPaletteZoneTemplateGrid().CreateNewZoneGroup();
                            break;

                        case PaletteZoneTemplateConstants.BUTTON_DELETE_GROUP:
                            getPaletteZoneTemplateGrid().DeleteZoneGroup();
                            break;
                    }

                    break;
                default:
                    getPaletteZoneTemplateGrid().LoadEditingTemplatePalette(buttonUIElement);
                    break;

            }
        }

        private PaletteZoneGroupingTemplate getPaletteZoneTemplateGrid()
        {
            var paletteInstances = EnergyPlusGUI.Common.FrameBroker.Frame.ModelPlayer.GetPaletteInstances(new Guid("62FFF98D-028E-4142-9B9D-CAFDB7DC12E8"));

            return paletteInstances.Cast<PaletteZoneGroupingTemplate>().FirstOrDefault();
        }
        */
        #endregion
    }

    public class PaletteZoneTemplateConstants
    {
        public const string BAND_ZONEGROUP = "Zone Group";
        public const string BAND_THERMALZONES = "Thermal Zones";

        public const string COLUMN_ZONEGROUPLIST = "Zone Group List";
        public const string COLUMN_OCCUPANCYANDCOMFORT = "Occupancy And Comfort";
        public const string COLUMN_LIGHTSANDDAYLIGHTING = "Lights And Daylighting";
        public const string COLUMN_ZONECONDITIONS = "Zone Condtions";
        public const string COLUMN_ZONECONSTRUCTION = "Zone Construction";
        public const string COLUMN_ZONENONHVACEQUIPMENT = "Zone Non HVAC Equipment";

        public const string COLUMN_THERMALZONE_NAME = "Thermal Zone Name";
        public const string COLUMN_THERMALZONE_OCCUPANCYANDCOMFORT = "Thermal Zone Occupancy And Comfort";
        public const string COLUMN_THERMALZONE_LIGHTSANDDAYLIGHTING = "Thermal Zone Lights And Daylighting";
        public const string COLUMN_THERMALZONE_ZONECONDITIONS = "Thermal Zone Zone Condtions";
        public const string COLUMN_THERMALZONE_ZONECONSTRUCTION = "Thermal Zone Zone Construction";
        public const string COLUMN_THERMALZONE_ZONENONHVACEQUIPMENT = "Thermal Zone Zone Non HVAC Equipment";

        public const string BUTTON_NEW_GROUP = "New";
        public const string BUTTON_DELETE_GROUP = "Delete";
        public const string BUTTON_EDIT_TEMPLATE_VALUES = "Edit Template Values";

    }


}
